Welcome

About NetServe Web Server

NetServe is a secure compact Web Server and File Sharing application for Windows NT, 95, 98, 2000, and XP.

Ideally suited for both home and business users, NetServe gives you the power to host your website on your own computer, and gives you access to a wealth of tools that allow you to Upload and Download from your computer remotely.

Key features include WebDAV which you can use with other WebDAV enabled products such as Microsoft Office and Adobe to read add write your files directly on your server.

Compelling Dynamic content is also available through the use of Server-Side-Include (SSI) support and CGI/1.1 support, giving you the choice of your preferred scripting language, including but not limited to; Perl, ASP and PHP.

File Sharing is made simple, through the intuitive and user friendly web interface allowing for directory browsing, upload and download.

With security in mind, NetServe features multiple authentication methods including Advanced Digest Authentication as well as comprehensive admin tools that allow you full control of who accesses your server.

Detailed Logs provide a high level of accountability for every file requested or uploaded on the server, these can of course be interrogated at a later date for statistics.

All these features make NetServe the ideal web hosting and file sharing solution.

NetServe is a fully supported application, which we are constantly improving upon, should users have suggestions for future updates please email us.

30 Day Trial

This is a fully functional 30 day trial version, for the latest pricing of NetServe please visit: http://www.netxsolutions.co.uk

Once you have purchased NetServe Online, your registration details will be emailed to you.

Product Updates

To get the latest update for this software, please visit http://www.netxsolutions.co.uk.


Standard vs Professional

Both standard and professional editions of NetServe provide exceptional performance and functionality.

There are some key differences for standard and professional editions however, and these are highlighted in the table below.

Features | Professional | Standard
File Uploading |  |
Remote Admin Console |  |
Local Admin Console |  |
Multiple Site Hosting |  |
Secure Digest Authentication |  |
Quotas |  |


Obtaining HTML Help Workshop

Obtaining NetServe Updates

Downloading NetServe

To download the latest version of NetServe visit: http://www.netxsolutions.co.uk

Installing NetServe

Before installing a newer version of NetServe Web Server, we strongly recommend un-installing any previous version. After downloading the installation file from the NetX website, double click the file to complete the installation process.


Contacting Us

Please send questions, feedback, suggestions and bug reports to:
support@netxsolutions.co.uk

Feature wish list

If you have suggestions for new features or changes you may like to see to existing ones, please email us your wish list to:
support@netxsolutions.co.uk, our applications are under constant improvement thanks to input from people like yourself, so by letting us know your thoughts on our products, you can help us to create better applications.


Overview

The main NetServe Web Server Options screen is available at all times by right clicking on the NetServe icon located in your system toolbar (bottom right of screen) and selecting "Server Options".

The Options screen is split into two main areas, the button bar (Left side) and the configuration window (Right Side).

The button bar is further more split into two categories, Global and Web Site.

Global, provides access to options that will effect the behaviour of NetServe on a global scale, any sites you host will use these settings.

Web Site, provides totally configurable settings that are unique to each individual web site you are hosting.
In the top right of the options screen you can see at a glance which web site you are currently editing, for the majority of users, hosting one site may be enough, in which case you will see DEFAULT displayed.
Should you be hosting multiple web sites, then the navigation buttons < and > will be enabled, allowing you to quickly change between configuration of each site.

  • Clicking OK will save any changes you made to the settings and will close this window.


First Use

NetServe is very simple to use, to start the web server running you can just double-click on the NetServe icon located in the system tray (bottom right of screen), you will notice the icon is different when the Server is active.

Server Off

Server Off The NetServe ball icon with red strips is displayed when the server is off.

Balloon Information

When the server is activated, either by double clicking on the taskbar icon, or selecting Start Server from the menu, you will see the balloon below appear.
The Local IP, is the IP address you can use to access your web server browsing from one of your home PC's. The Remote IP is the IP Address you would use when you would like to view your web server from a computer on the internet. (This is the IP address that internet users will use)

Server On

Server On The NetServe ball icon with blue strips can be seen, when the server is on.

You can access help and options by right clicking on the icon.


Custom CGI Variable

Custom CGI Variables

Custom CGI Variables can be used to pass a value globally to all CGI applications, The CGI application will process the variable as if it had been transferred as part of the usual process, in fact some CGI Interpreters such as PHP may require certain CGI Variables to be defined and passed to it in order to function correctly.

A list of the CGI Variables that are automatically sent to a CGI Interpreter as part of its usual process, are included in this help documentation.

Add/Edit Custom CGI Variables

CGI Variable

The name you wish to assign to a CGI Variable that will be transferred to a running CGI Application. This can be any string for example REDIRECT_STATUS

CGI Value

The value you wish to assign to the CGI Variable, this value for example; 200, will be sent to the CGI Application every time a php, perl, or other script is being interpreted.


Custom Errors

By default if an error occurs within the web server a HTTP Status code is sent back to the clients browser, this will take the form of HTTP/1.1 - <STATUS CODE> <STATUS DESCRIPTION> for example: HTTP/1.1 - 404 Not Found

However there are situations where this simple message may not be enough, you may want to display a complete web page, in the style of your web site, this can be achieved with ease using the Custom Errors screen.

If an entry appears in the custom errors list for any given status code, then the file mentioned in the list will be sent to the user instead of the simple status message as shown above.

Error Code

An error code can be any valid Status code that can be produced by the web server. With the exception of the 2xx status codes as these codes indicate a success and not an error. A complete list of the Status codes and their corresponding descriptions are available in this documentation.

File Path

The file path must be a logical path pointing to a html file only, for example: “D:\Errors\404.html”


File Resuming

A major new feature of NetServe Web Server is the ability to resume downloads, all popular download managers can now resume downloads of any size from the NetServe Web Server, or download only selected chunks of data to decrease on bandwidth usage.

This is especially useful in the following situations:

  • You are downloading a file from the server, but would like to pause the download while doing something else.
  • Your connection to the internet has been broken, and you would like to resume the download from where you left it.
  • You need to carry out maintenance to the server and need to restart the machine, clients can simply resume the download as soon as the machine reboots.


Folder Security

Using the Folder Security screen you can define which Aliases have security enabled, the realm (a simple text description that will be displayed to the user) and the users that will be permitted to access this resource.

Enter an Alias and Realm description and then click Add, you can now use user/Groups allocation buttons [<-] and [->] to specify Allowed Users or Groups.

Alias

Alias should be one of the Aliases previously defined in the Aliases screen, and must always begin with a “/” symbol.

Realm

The realm is simply a text description of the resource that will be protected; the Realm is used as part of the Digest authentication method therefore each realm description should be unique per alias to ensure the highest level of security.

Folder Options

The following folder options are now available for every Alias you define, they are: Enable WebDAV, Allow Directory Browsing, Allow Scripts and Allow File Upload


Groups

Groups makes it much easier to manage a large number of user accounts, you could for example create two groups, Administrators and StandardUsers, and then assign users to each of these two groups as you see fit.

Now instead of assigning users to every folder to give access to them, you simply need to allow access to the group StandardUsers. By adding StandardUsers in the folder security screen, all users who are a member of the StandardUsers group will automatically be given access to that resource.


IP Access Lists

IP Access Lists allow you to either allow or deny IP addresses using the following formats:

  • 192.168.0.* (Addresses from 0-255)
  • 192.168.0.0/24 (Addresses from 0-255)
  • 192.168.0.15 (Specific IP Address)
  • 192.168.0.1-15 (Addresses from 1-15)

Allow or Deny

NetServe operates in two different IP filtering modes:

  • Allow only IP's in this list, DENY all other IP's
  • Deny only IP's in this list ALLOW all other IP's
The first should be primarily used if you want to limit access to your server to only a small handfull of known PC's.
The second option (the default) will all IP address on the internet to access your web server, except for any addresses in the list.

Access Denied Page

When an IP address is block because it matches one of the IP rules you have specified, instead of displaying the requested page, an alternate Access desnied page is displayed, using the "Access Denied Page" option you can choose this page.


MimeType Settings

MimeTypes are what tells a clients browser what to do with the document that the server has just sent, for example for a browser to correctly play a music file of type mp3, the server needs to send the appropriate MimeType, this being "audio/mpeg".

A file has been supplied with NetServe called config.dat, this file contains 70+ of the most common MimeTypes as well as the current settings for NetServe.

Should you however need to add extra MimeTypes you can use either the Add/Edit MIME Type window accessed from the Server Options screen, or by using the Web managed Admin Console, alternatively you can edit the config.dat text file using your favourite text editor (This method is not recommended). MimeTypes application/pdf|pdf Each MimeType is contained on its own line the syntax of the line is as follows:
Mimetypes <MimeType>|<Extension1> <Extension2> <Extension3...etc>

For example an mp3 MimeType line entry would look like:
MimeTypes audio/mpeg|mpga mp2 mp3

The MimeType should always be at the start of the line and each file extension that is to use that MimeType should appear after, space separated, and there must be at least one file extension.


Remote Admin Console

Default login details for the Remote Admin Console are as follows:
Login: Admin
Password: NetServe

It is highly recommended that you change these at your first opportunity through the Users menu.

New to NetServe Web Server is the Remote Admin Console, giving administrators the ability to log on to their Web Server remotely through any popular web browser in order to perform administration tasks.

The Remote Admin Console, gives access to all options within NetServe in a concise and consistent look and feel, so learning how to use the console is a breeze.

To log onto the Remote Admin Console simply enter http://%severip%/admin/ into your browser of choice, replacing %serverip% with the IP Address of the NetServe Web Server, this can be found by placing the mouse over the NetServe icon located in the system tray at the bottom right of the screen.

NetServe is capable of hosting multiple web sites, however by default only one site is present, DEFAULT, to access the complete configurations for this site, click the "Configure This Site" button.

Remote Admin Console

A brief description of the Remote Admin Consoles main page and functionality follows, however for an in-depth description of individual options you should read the appropriate help section.

The main page displays the current eleven icons required to access the full functions of NetServe, by clicking on either the icon or its associated text below it, will display the appropriate options for that section.

These may either consist of individual options such as text boxes which require text to be entered, tick boxes providing a yes/no answer or a list of entries may also be displayed.

Lists can be edited, new entries added, or entries deleted, a good example of this is the list of available MIME Types.

Enabling/Disabling Remote Admin Console

In order to enable or disable the Remote Admin Console you need to right click the NetServe icon located in the system tray and selecting Server Options, tick the option “Enable Remote Admin” to enable the remote admin console, or un-tick it to disable the option.


Sharing Directories (Aliases)

Sharing directories located on any drive of your computer is a simple process, and it means that your data doesn't all have to reside in the wwwroot folder.

When you specify a directory to share, you also specify an alias (A short name to describe your directory).

Once set up you can then access the contents of that directory by entering in the alias you created, you could think of these Aliases as shortcuts to the files you want to access.

For example in the screenshot above a number of Aliases have been defined, lets focus on the MyPhotos alias.
If you wanted to access the data located in "D:\MyFiles\MyPhotos" you would only need to specify in your web browser "http://127.0.0.1/MyPhotos/".


Welcome

Site List

NetServe supports the hosting of multiple web sites from the same server.

Heres how it works:
When a user requests a web site, such as www.netxsolutions.co.uk NetServe automatically detects the host name and returns only the data relevant to that website. By doing this NetServe is capable of hosting hundreds of peoples websites all from your computer (Why not become your own Web Hosting Service)

You can Add, Edit and Remove new sites from either the Remote Admin Console or locally through the Site List window.

DEFAULT is the default web site and cannot be deleted, it is the site that users visiting your Web Server will see if they do not specifiy a host name that is in your list, or if they access your server directly using its current IP Address.

Remote Admin - Site List


Welcome

SSI Options

The options available in this window allows you to define the default behaviour of any Server-Side Includes taking place, any of these options you set can however be overridden should the author of a SSI wish by using the #config directive.

SSI Options

The screen above shows one possible configuration, an explanation of each option follows:

Enable SSI

Self explanatory, when this tick box is checked, the server will parse any pages that match the SSI Extensions and perform the relevant SSI operations.

SSI Extensions

Here you can define extra file extensions which you require SSI operations to be performed on, please note that to perform SSI operation will cause a very small performance hit, for this reason it is not advised to set very commonly used extensions such as "html" in this field, you should use "shtml" for this purpose.

SSI Error Message

The default of NetServe is to provide detailed information when an SSI error occurs, however you can override this by specifying a general error message that will be displayed regardless of the error. To revert to displaying detailed error messages, blank this field.

This option can be overridden by a user by using the #config directive.

Time Format String

You can change the default format of any date and times output using SSI, by specifying format strings in the standard Unix format, details of the available formatting options are available in the #config explained section

Abbreviate File Size

If set the file size displayed with the #fsize directive will be abbreviated like; 1.00MB otherwise the total size of a file in bytes will be displayed.


User Security Settings

NetServe now support three user authentication methods, Cookie, Basic and Digest, changing security options here will effect security permissions globally across all areas of your site and any server virtual paths.

User Password Security Options Screen

To enable site-wide security, ensure the "Enable password protection" check box is ticked, it is recommended that the Basic Authentication option be used, as this provides a greater level of security over Cookie Authentication.

For a detailed explanation of the three authentication methods read the Authentication Methods section.


Languages

As NetServe continues to grow in popularity so does the number of languages it's available in.

This installation comes with six languages installed by default, other languages will become available and will be downloadable from our web site; www.netxsolutions.co.uk. Current Languages are:

  • English
  • French
  • German
  • Italian
  • Spanish
  • Portuguese
You can change the language that NetServe uses by clicking the Languages button from the Server Options screen, all available languages are then displayed.

Select your choice of language then click OK to confirm.

You must now close, and restart NetServe Web Server completely in order for the language settings to take effect.


Adding CGI Interpreters

To access the CGI Interpreters window, right click on the NetServe System Tray Icon found at the bottom right of your screen. A menu will appear, select Server Options, the Server Options window will appear, click the CGI Interpreters button.

The screen above shows how to correctly configure NetServe to run Perl Scripts.

To add a new CGI Interpreter, you will first need to have installed the appropriate Interpreter onto the same machine that is running NetServe, or have a visible path to the Interpreter.

Enable CGI Interpreters

In order to use CGI Interpreters this option must be ticked.

CGI Scripts Timeout (Seconds)

If a CGI application becomes unresponsive NetServe can terminate that application and send an appropriate response back to the client informing them of the scripts failure. The timeout by default is set to 20 seconds which should give the vast majority of scripts more than enough time to complete.

Setting the File Extensions

For this example we will show you how to set up NetServe to run Perl Scripts. Once you have installed the CGI Interpreter, using the CGI Interpreters window, enter each file extension you wish to be interpreted, for example for Perl we would need to enter both pl and cgi extensions so you would enter "pl cgi", more than one File Extension can be supplied but they must be separated by spaces.

Setting CGI Interpreter Path

Now enter the complete CGI Interpreter path into the for example "D:\Perl\bin\perl.exe" clicking add will add this Interpreter into the CGI Interpreters List, clicking OK will confirm the changes and close the window.

If you plan on using the CGI Interpreters ensure that the "Use CGI Interpreters" check box is ticked before clicking OK on this window.


CGI Environment Variables

Twenty two Environment variables are currently being sent to the CGI Interpreters.
These are:

CONTENT_LENGTH
CONTENT_TYPE
GATEWAY_INTERFACE
HTTP_ACCEPT
HTTP_ACCEPT_CHARSET
HTTP_ACCEPT_ENCODING
HTTP_ACCEPT_LANGUAGE
HTTP_CONNECTION
HTTP_COOKIE
HTTP_PRAGMA
HTTP_REFERER
HTTP_USER_AGENT
PATH_INFO
QUERY_STRING
REMOTE_ADDR
REMOTE_HOST
REMOTE_PORT
REQUEST_METHOD
SERVER_ADDR
SERVER_PORT
SERVER_PROTOCOL
SERVER_SOFTWARE
SCRIPT_FILENAME

For information on how to access these variables in either SSI or CGI scripts check out the supplied examples in the examples folder in the application directory.


About SSI

Server-Side Includes are a set of directives that allows you to add basic dynamic content to an otherwise static web page, SSI directives are interpreted much like other CGI Interpreters, except this interpretation is done directly by NetServe Web Server.

The following types of information can be included using SSI.

  • Environment Variables (Both CGI and extra SSI Variables) using #echo directive.
  • Size and the Last Modified dates of files using #flastmod and #fsize directives.
  • The content of a specified file using the #include directive.
  • Or the results of a CGI script or a shell command.

Certain configurations can be made to alter the way in which information is output, this can be done using the #config directive.


About the SSI #Echo Directive

The SSI #Echo Directive gives access to the following variables that can be inserted into a HTML document before being sent to the user.

Example Usage:

Returns the last modified date of this file
<!-- #echo var = "LAST_MODIFIED" -->

Displays the Query String, The information immediately after the ? in the URL
<!-- #echo var = "QUERY_STRING" -->

Shows the name of the file being displayed
<!-- #echo var = "DOCUMENT_NAME" -->

You can also echo the variables that are used by CGI applications, these are echoed identically to the methods used above.

A complete list of NetServe supported CGI Variables.


About the SSI #FLastMod Directive

The SSI #FLastMod Directive inserts the last modified date and time of a file specified using either the "file" or "virtual" parameters.

The way in which the file last modified date and time is displayed can be changed on a per page bases using the #config directive, or you can change the default file size behaviour in NetServe SSI Options screen.

Example Usage:

The file method inserts the last modified date of a file from within the same root as the currently processed html file.
<!-- #include file="/cgi-bin/example.txt" -->

The virtual method inserts the last modified date of a file from anywhere that is accessible to the Web Server
<!-- #include virtual="/cgi-bin/example.txt" -->


About the SSI #FSize Directive

The SSI #FSize Directive inserts the file size of the file specified using either the "file" or "virtual" parameters.

The way in which the file size is displayed can be changed on a per page basis using the #config directive, or you can change the default file size behaviour in NetServe SSI Options screen.

Example Usage:

The file method inserts the file size of a file from within the same root as the currently processed html file.
<!-- #include file="/cgi-bin/example.txt" -->

The virtual method inserts the file size of a file from anywhere that is accessible to the Web Server
<!-- #include virtual="/cgi-bin/example.txt" -->


SSI #config Explained

The following are valid #config directives: timefmt, sizefmt and errmsg, and are explained in detail below.

timefmt

Example Usage:<!-- #config timefmt="%A %d %B %Y" -->

Whenever SSI outputs a date either from the Last Modified echo directive or the flastmod directive, you can use #config to alter the formatting of the date and time.

To change the Date and Time formatting within an SSI page use the following syntax
<!-- #config timefmt="%A %d %B %Y" --> this will display "Wednesday 11 June 2003"

Any combination of the options below can be used to create a date time format of your choice, the #config directives only need to be used once within an SSI page as the settings you make will be used for all subsequent date and time outputs, however should you wish to output the date or time differently in certain areas of your page you can call the #config again specifying different format options.

timefmt parameters

  • %a: Abbreviated name for day of the week.
  • %A: Complete name for day of the week.
  • %b: Abbreviated month name.
  • %B: Complete month name.
  • %c: Date and time representation.
  • %d: Day of the month (01-31).
  • %H: Hour in 24-hour format (00-23).
  • %I: Hour in 12-hour format (01-12).
  • %j: Day of the year as a decimal number (001-366).
  • %m: Month as a decimal number (01-12).
  • %M: Minute as a decimal number (00-59).
  • %p: A.M. or P.M. indicator for 12-hour format.
  • %S: Second as a decimal number (00-59).
  • %U: Week of the year as a number (00-51). Sunday is the first day of the week.
  • %w: Day of the week as a number (0-6). Sunday is the first day of the week.
  • %W: Week of the year as a number (00-51). Monday is the first day of the week.
  • %x: Date representation.
  • %X: Time representation<-- for the current C locale-->.
  • %y: Year without the century (00-99).
  • %Y: Year with the century (0000-9999).
  • %z: Time zone name; empty if unknown.
  • %Z: Time zone name abbreviation; empty if unknown.
  • %%: Percent sign.

sizefmt

Example Usage:<!-- #config sizefmt="abbrev" -->

The sizefmt option has only two valid settings, abbrev or byte, abbrev will cause any subsequent filesizes displayed using #echo to display in an abbreviated format for example 1.00MB, while the byte value will cause the filesize to be displayed in total number of bytes.

errmsg

Example Usage:<!-- #config errmsg="An Error Occurred" -->

The errmsg can be used to override the default behaviour when an error occurs, by default a detailed error message will be displayed to the user upon an SSI error, however using this directive you can display a generic message of your choice for example: "An Error Occurred".


About the SSI #Include Directive

The SSI #Include Directive allows the content of another file or the results a cgi file to be included into a html file. There are two uses of this directive, either using the "file" parameter or the "virtual" parameter.

Example Usage:

The file method includes a file from within the same root as the currently processed html file.
<!-- #include file="/cgi-bin/example.cgi?argument=value" -->

The virtual method includes a file from anywhere that is accessible to the Web Server
<!-- #include virtual="/cgi-bin/example.cgi?argument=value" -->


An Introduction to WebDAV

WebDAV is an exciting addition to the HTTP Protocol that enables Clients and Server applications to communicate more easily, therefore allowing for greater management and utilization of the information stored on a server.

WebDAV at its simplest allows enabled clients, to seamlessly integrate with NetServe Web Server, allowing a user to download a file, perhaps an image, edit the image using there favourite paint package and then re-save it to the web server, all this without even needing to leave the paint package application.

As the technology evolves more and more applications are being WebDAV enabled, but its easy to take advantage of WebDAV today by using NetServe Web Server, along with any of the following applications;

  • Microsoft Windows (via Web Folders starting with IE 5.0)
  • Microsoft Internet Explorer
  • Microsoft Office
  • Adobe Acrobat 5
    Reviewers can add comments simultaneously to an online Adobe PDF document with many protocols including WebDAV.

  • Adobe GoLive
    A professional web site creation, production, and management tool.
  • Adobe Photoshop

So what does this mean for you?

It means greater flexibility and freedom for you, no longer will you be stuck at work, needing a file that you left at home, you can use Microsoft Web Folders to connect to your home PC and access your file securely through NetServe Web Server, much the same way that you would map a network drive.

And as it works completely on the standard http protocol, if you can access the internet from work, then you should have no problems accessing your data.


An Introduction to WebDAV

Connecting to WebDAV Using Web Folders

Using Microsoft Web Folders and NetServe Web Server, you can access data similar to how you would with a mapped network drive.

This "Mapped Drive" can be seen by applications, running on your computer, as well as enabling files to appear in Windows explorer and your Network Places.

This gives you quick and easy access to your files located on your server, whilst avoiding the need for usual ftp applications.

Files can be Uploaded, downloaded, renamed, deleted and moved, in fact any operation you would usually carry out in Windows Explorer.

To create a New Network Place:

Click Start/My Network Places under Network Tasks click "Add a network place"

The Add Network Place Wizard will start

Click Next to continue and Next again

Enter the Internet or Network address:
in the format http://<YourIP>:Portnumber/<YourAlias> for example http://127.0.0.1:80/mymusic

Press enter.

Logging onto a secure WebDav Folder

    Note: If the folder you are trying to connect to is a webDav folder that is protected with either Basic or Digest Authentication it is required to enter the port number, ie. 80, failure to do so will result in the inability to log on with your credentials.

    A login dialog box will appear requesting that you enter a user name and password.

    Enter both your username and password to log onto the webDav resource.

Create a name for this shortcut that will help you easily identify this network place If a successful connection to the server occurred you will be prompted to "Type a name for this network place"

Enter a name and then click next

Open this network place when I click Finish

will open the folder as soon as you click Finish,


HTTP Status Codes

Informational...

100 Continue
101 Switching Protocols

Successful...

200 OK
201 Created
202 Accepted
203 Non-Authoritative Information
204 No Content
205 Reset Content
206 Partial Content

Redirection...

300 Multiple Choices
301 Moved Permanently
302 Found
303 See Other
304 Not Modified
305 Use Proxy
306 (Unused)
307 Temporary Redirect

Client Error...

400 Bad Request
401 Unauthorized
402 Payment Required
403 Forbidden
404 Not Found
405 Method Not Allowed
406 Not Acceptable
407 Proxy Authentication Required
408 Request Timeout
409 Conflict
410 Gone
411 Length Required
412 Precondition Failed
413 Request Entity Too Large
414 Request-URI Too Long
415 Unsupported Media Type
416 Requested Range Not Satisfiable
417 Expectation Failed

Server Error...

500 Internal Server Error
501 Not Implemented
502 Bad Gateway
503 Service Unavailable
504 Gateway Timeout
505 HTTP Version Not Supported


Authentication Methods

NetServe Web Server features three different forms of user authentication, each with its own advantages, we recommend that the strongest form of authentication be used, this is “Digest Authentication”, however there may be circumstances where a different security level may serve you better. Below follows a more detailed description of the three levels of security along with the advantages and disadvantages of each.

Digest Authentication (High Security)

This method is the strongest security level available to NetServe administrators and is the one we recommend using 100% of the time, with digest authentication you can rest assured that user passwords remain secured and that your system will not be compromised.

All user sensitive data is encoded using a one way MD5 hash, further more, NetServe employs advanced Digest methods which ensures that such attacks as replay attacks cannot take place.

However Digest or Advanced Digest authentication mechanisms can not be enabled if the target browsers do not support HTTP 1.1. Internet Explorer 5.0 and above support HTTP 1.1, as well as recent versions of Netscape, Opera, Mozilla and other popular browsers.

Basic Authentication (Medium Security)

Sends the username and password Base64 encoded across the network, while this will deter a casual person from discovering your user logins it would not stop someone with intent to access your system. As with Cookie Authentication both Basic and cookie methods are vulnerable to Replay attacks and the likes.

Cookie Authentication (Low Security)

This Is the lowest form of security available, username and password are sent across the network in clear text format, and thus your system will be vulnerable to reply attacks and the likes.

The advantage of Cookie Authentication is that it is supported by any browser that supports cookies, and the logon method is supplied via a customizable html page so you can use this method to quickly protect your site.

Due to the nature of this authentication method it is strongly recommended NOT to use this method if you wish to protect sensitive data.


Quotas

Adding quotas is a powerfull way to control the amount of data that can be uploaded to your server.

You can define Quotas for any folder that is located on your computer, and allocate it a maximum storage space ie 1000MB.
When this target is reached, the upload feature will automatically become unavailable to users.

Quota Path

Specify the absolute path of the folder you wish to assign a quota to.r permissions you want to apply to this folder (and sub folders) are ticked, then click Add and OK.

Size (MB):

The maximum storage allocation for the Quota path.


Log Files

Log files produced by NetServe adhere to the National Center for Supercomputing Applications (NCSA) Common and Combined Log Format.

This standardized and commonly used log format, will allow you to use statistical programs for monitor web hits etc.

The common log file format is as follows:

remotehost rfc931 authuser [date] "request" status bytes

remotehost

  • Remote hostname (or IP number if DNS hostname is not available, or if DNSLookup is Off.
rfc931
  • The remote logname of the user.
authuser
  • The username as which the user has authenticated himself.
[date]
  • Date and time of the request.
"request"
  • The request line exactly as it came from the client.
status
  • The HTTP status code returned to the client.
bytes
  • The content-length of the document transferred.

You can also enable extended logging which will also cause the Referer and the User Agent details to be appended to this log syntax.

Logging Intervals

The log files can be saved in intervals of:
  • Hourly
  • Daily
  • Weekly
  • Monthly
  • Unlimited File Size


Apple MAC considerations

When uploading or downloading files using an Apple MAC the following should be considered

How the MAC Stores files

The Macintosh is unique in that it's files have 2 components - a Data fork and a Resource fork.

An example of this would be what information an application like Adobe PhotoShop(R) will store when running on the Mac. In this example, the actual image data is contained in the Data fork.

This is consistent with other platforms. However, in the Resource fork, specific Macintosh information is stored - like thumbnail icons, etc.

When uploading to a WebDAV enabled folder, a Mac will upload both it's Resource Fork and the Data Fork (Resulting in two files being present on the server.

The format employed by NetServe is the Apple Double Format. Using this format, 2 distinct files are stored on the WebDAV server.

The data component is stored and the resource fork is also stored in a 'hidden' file. Use of this encoding should be seamless between MacOSX;

however users on other platforms may see files that begin with "._"; these are the special Apple files and can be safely ignored. You can elect to Hide the ._ files from the users browsers however this could result in unexpected behaviour with Mac clients that require the ._ files.

How to hide Mac Resource Files from other platforms

Open the config.dat file using notepad and add the following parameter to the bottom of the file:

HideMacResourceFiles True

This will hide the ._ Resource Fork Files

HideMACResourceFiles False

This Shows all files (DEFAULT)


Firewall Troubleshooting

Windows XP

By default Windows XP's built in firewall is configured to block communication from the outside world to any Web Server software running on your computer, you should therefore make the following checks and changes to the firewall settings in Windows XP.

How to check Windows XP Firewall settings

Click Start, Connect to, Show all connections...

Look for the connection which you use to access the internet, if this connection has a small padlock at the top right then Windows XP has enabled a firewall for this connection, by default it is set to disallow communication to a web server running on your local machine, and before your Web Server can send pages to the outside world a setting change must be made.

Enabling Web Server (HTTP) Protocol

To change the setting, right click and select properties, click the Advanced tab, at the bottom right click Settings, a list of protocols will now be shown, ensure that the Web Server (HTTP) protocol is ticked. Click OK to confirm any changes.


How Do I Configure My Router

Question

I recently purchased an ADSL Router, but now users on the internet cannot see my Web Server, What's wrong?

Answer

All routers require configuring the NAT settings in order for outside users to be able to see your web server, although the method for applying this configuration may change based on individual manufacturers hardware and software implementations.

The computer running your NetServe software should be configured with a static IP address.

We have included a brief description on how to configure the Alcatel Pro, SMC Networks and Linksys Routers below, if however you have a router by a different manufacturer, it is recommended to contact them with help in configuring the device for use with a web server.

Alcatel Pro

Enter the IP address of your ADSL Router into your browser window, to display the configuration pages.
If your ADSL is password protected enter those details. Click on the NAT option in the left hand menu screen, you will now need to enter the following details into:
  • Protocol: TCP
  • Inside IP: <Enter the IP Address of your Web Server, Usually a 192.168.XXX.XXX address>
  • Inside Port: 80
  • Outside IP: 0.0.0.0
  • Outside Port: 80
Then click the Add button, and click Save All.

You may need to turn the router off and back on again for this change to take effect.

SMC Networks

For SMC Networks' routers, you should add the IP address and the Port number of your Web Server into the "Virtual Server" section of the NAT configuration page, using a data type of "TCP".

You may need to turn the router off and back on again for this change to take effect.

LinkSys Wireless AP (BEFW11S4)

From within the LinkSys admin page, click the Advanced tab on the upper right corner. Once the new page appears, click on the Forwarding tab.

You now need to add an entry into the forwarding table.

  • Customized Applications:
  • Ext. Port: 80
  • Protocol: TCP
  • IP Address:
  • Enable: Select Enable to enable this forwarding entry.

Click Apply at the bottom of the page to make the changes, then reboot the Router.


What Do I Receive When I Buy NetServe?

Question

I would like to purchase NetServe Web Server, What do I receive when I buy It?

Answer

NetServe Web Server at present only ships in electronic form, when you purchase NetServe Web Server online you will receive via email an activation/registration code that fully activates a trial version of our software, we do not ship any physical media such as CD, packaging or manual.

However, as the popularity of NetServe Web Server continues to grow we do anticipate producing a physically packaged product, at this stage we will give users the choice of purchasing either the electronic online version, or a physically packaged product.


How To Use A Domain Name

Getting NetServe Web Server running from home, with a Domain name is actually a pretty simple task.

Once all the steps below have been performed you will be able to access your website using www.mydomain.com (Where 'mydomain' is the Domain you register).

Below is a quick step by step guide:

As you most likely have a modem/dsl connection to the internet, your IP address will change every time you connect to the internet, for this reason you cannot simply purchase a domain name, you must first register with a DNS service such as ZoneEdit.

Step 1 - Register with ZoneEdit

Register with ZoneEdit at http://www.zoneedit.com/signup.html
This is a FREE DNS service (depending on your bandwidth usage) that is used to keep track of your current IP and ensures that a users domain request gets through to your computer.

Step 2 - Register you Domain Name

Register your Domain name with any of the many Domain Registration companies available on the net, when asked to supply the IP addresses of your DNS servers use the IP Addresses supplied by ZoneEdit.
If you already have a Domain name registered, simply ask your registrar to change the IP addresses for the DNS Server to point to those supplied by ZoneEdit.

Step 3 - Configure ZoneEdit

Login to ZoneEdit and confirm the details of your Domain Name.

Step 4 - Install Dynamic IP Software

Install some Dynamic IP software on your computer, and configure it for use with ZoneEdit, we recommend DynDNS www.sitedevelopers.com/dyndns this software will keep ZoneEdit's DNS Server up to date with the IP address of your computer.

We would recommend reading the FAQs provided on these sites.


How To Enable Scripts

By default scripts are disabled, should you however wish to add dynamic content to your web site, scripting languages such as asp, perl or php will be required. The steps below will guide you through how to enable scripts to run.

  1. It is recommended that you place all your script files (.php, .asp, etc...) in a folder called "scripts" Create a folder called "scripts" in "C:\program files\NetServe Web Server\wwwroot" folder.
  2. From Server options click the Aliases button, and enter the following details:
    Alias: /scripts
    Mapping: C:\program files\NetServe Web Server\wwwroot\scripts
    Click the Add button followed by the OK button.
  3. From Server Options click the Folder Security button, and enter the following details:
    Alias: /scripts
    Realm: Scripts
    Tick the "Allow Scripts" option (This will allow your scripts to be run)
  4. If you haven't already done so, then install and follow the setup guide for one of the following scripting languages: ASP, Perl or PHP.


How To Add ASP Support

NetServe Web Server supports many different scripting languages through the use of the Common Gateway Interface (CGI), such as ASP, Perl and PHP.

There are three simple steps to successfully add ASP support to NetServe, they are:

  1. Download the ASP Interpreter, ActiveHTML from SeliSoft
    http://www.selisoft.com/en/ahtml
  2. Once downloaded run the installation package and follow its on screen prompts.
  3. You will now need to add some NetServe settings.

Setting the File Extensions

Right click on the NetServe icon in the system tray (bottom right of screen) and select "Server Options" from the menu.

Now click on the CGI Interpreters button, using the CGI Interpreters window, enter "asp asa" as the file extensions, this will allow ActiveHTML to interpret files with extensions of both asp and asa.

Setting CGI Interpreter Path

Now enter the complete CGI Interpreter path, this will be the path where you installed ActiveHTML, which by default would have been "C:\Program Files\ActiveHTML\ahtml.exe" clicking add will add this Interpreter into the CGI Interpreters List, clicking OK will confirm the changes.

If you plan on using the ActiveHTML Interpreter straight away, ensure that the "Use CGI Interpreters" check box is ticked before clicking OK on this window.

Setting the Appropriate Security Levels

To allow scripts to be run you must set the security level of the folder containing your ASP Scripts.

In The Folder Security screen, add an alias (for example /CGI-BIN) with a Realm description of your choice (The longer the more secure).

Ensure the "Allow Scripts" check box is ticked, and any other permissions you want to apply to this folder (and sub folders) are ticked, then click Add and OK.


How To Add Perl Support

NetServe Web Server supports many different scripting languages through the use of the Common Gateway Interface (CGI), such as ASP, Perl and PHP.

There are three simple steps to successfully add Perl support to NetServe, they are:

  1. Download the Perl Interpreter, ActivePerl from ActiveState
    http://www.activestate.com/Products/ActivePerl
  2. Once downloaded run the installation package and follow its on screen prompts.
  3. You will now need to add some NetServe settings.

Setting the File Extensions

Right click on the NetServe icon in the system tray (bottom right of screen) and select "Server Options" from the menu.

Now click on the CGI Interpreters button, using the CGI Interpreters window, enter "pl cgi" as the file extensions, this will allow ActivePerl to interpret files with extensions of both pl and cgi.

Setting CGI Interpreter Path

Now enter the complete CGI Interpreter path, this will be the path where you installed ActivePerl, which by default would have been "C:\Perl\bin\perl.exe" clicking add will add this Interpreter into the CGI Interpreters List, clicking OK will confirm the changes.

If you plan on using the ActivePerl Interpreter straight away, ensure that the "Use CGI Interpreters" check box is ticked before clicking OK on this window.

Setting the Appropriate Security Levels

To allow scripts to be run you must set the security level of the folder containing your Perl Scripts.

In The Folder Security screen, add an alias (for example /CGI-BIN) with a Realm description of your choice (The longer the more secure).

Ensure the "Allow Scripts" check box is ticked, and any other permissions you want to apply to this folder (and sub folders) are ticked, then click Add and OK.


How To Add PHP Support

NetServe Web Server supports many different scripting languages through the use of the Common Gateway Interface (CGI), such as ASP, Perl and PHP.

There are three simple steps to successfully add PHP support to NetServe, they are:

  1. Download the PHP Interpreter from
    http://www.php.net/downloads.php
  2. Once downloaded run the installation package and follow its on screen prompts.
  3. You will now need to add some NetServe settings.

Setting the File Extensions

Right click on the NetServe icon in the system tray (bottom right of screen) and select "Server Options" from the menu.

Now click on the CGI Interpreters button, using the CGI Interpreters window, enter "php" as the file extension, this will allow PHP to interpret files with extensions of php.

Setting CGI Interpreter Path

Now enter the complete CGI Interpreter path, this will be the path where you installed PHP, which by default would have been "C:\PHP\php.exe" clicking add will add this Interpreter into the CGI Interpreters List, clicking OK will confirm the changes.

If you plan on using the PHP Interpreter straight away, ensure that the "Use CGI Interpreters" check box is ticked before clicking OK on this window.

Setting the Appropriate Security Levels

To allow scripts to be run you must set the security level of the folder containing your PHP Scripts.

In The Folder Security screen, add an alias (for example /CGI-BIN) with a Realm description of your choice (The longer the more secure).

Ensure the "Allow Scripts" check box is ticked, and any other permissions you want to apply to this folder (and sub folders) are ticked, then click Add and OK.

Security Permissions

Adding the following entry into the Custom CGI Variables is required for PHP to operate correctly.
Add the CGI Variable REDIRECT_STATUS and the CGI Value of 200


How to Setup a PHP Web Forum

There are numerous Forums available to use based on different languages, one of the best is PHPBB, as it's name suggests it utilizes the very popular PHP language.

Installing a PHP Interpreter

In order to use PHPBB you will first need to have successfully installed a PHP interpreter.

We recommend using the freely available PHP Interpreter from PHP.org
First follow our guide: How To Add PHP Support

Download PHPBB

Download the latest version of PHPBB from http://www.phpbb.com/downloads.php
Unzip the files contents and copy the folder "PHPBB2" and all of its contents into the wwwroot directory.
This usually located in C:\Program Files\NetServe Web Server\wwwroot\

Database Settings

PHPBB supports many varying Database formats, this guide will only explain how to get PHPBB working with the most simplest DB, this being Microsoft Access.

If you require PHPBB to work with a different DB ie SQL Server or MySQL please use the documentation that comes with the PHPBB zip file.

Unzip the contents the ms_access_primer.zip now located in; C:\Program Files/NetServe Web Server/wwwroot/phpbb2/install/schemas/
The ms_access_primer.mdb file can be placed anywhere on your computer, however for security reasons do not place it within the wwwroot directory.

Setting UP ODBC

Select Start/Control Panel/Administrative Tools/Data Sources (ODBC)
From the list Select "Microsoft Access Driver (*.mdb)
Click Finish
Enter the following details:
Data Source Name: PHPBB
Description: My PHPBB Database

Click the Select... button
Browse to the location where you placed the ms_access_primer.mdb Click OK, OK

NetServe Settings

Only a very few settings now need to be added to NetServe to enable the PHPBB.
Select Server Options

Click the Aliases button

  • Enter the following details:
  • Alias: /phpbb
  • Mapping: C:\Program Files\NetServe Web Server\wwwroot\phpbb2\
  • Click Add button
  • Click OK button to save these settings
Click the Folder Security button
  • Enter the following details:
  • Alias: /phpbb
  • Realm: My PHP Forum
  • Tick: Allow Scripts only
  • Click Add button
  • Click OK to save these settings

PHPBB Settings

Ensure that all of the settings above have been completed before proceeding.

The configuration of PHPBB requires a static IP or a domain name, we recommend using the free service from no-ip for this purpose.

You can now access the configuration pages for PHPBB from the following URL: http://:/PHPBB/index.php
If you are unable to connect to the configuration page, please check that all the operations have been followed.

For the rest of the configuration please follow PHPBB's web setup.
If you are experiencing problems when using or setting up the PHPBB product please refer to PHPBB's web site www.phpbb.com.


PDF Documents do not open properly.

When I click on a PDF form I get a blank page and/or an error message. What can I do?

Enabling the Browser to Use Acrobat as a Helper Application

Certain builds of Netscape, Internet Explorer and AOL do not properly display embedded PDF files, even if Acrobat Reader is installed. Instead they display a blank screen, an error message or a blank screen with a small document image in the upper left corner.

Examples of some of the error messages:

  • "File does not begin with '%PDF-'"
  • "Error reading xref entry."

To get around this Adobe recommends configuring Acrobat as a helper, not a plug-in, here's how you do it:

To configure Acrobat or Acrobat Reader as a helper application:

  1. Exit from Netscape, Internet Explorer and/or AOL.
  2. Start Acrobat or Acrobat Reader.
  3. Choose Edit > Preferences > General (Acrobat 5.x or Acrobat Reader 5.x).
  4. Choose Edit > Preferences > Internet (Acrobat 7.x or Acrobat Reader 7.x).
  5. In the Options section, deselect Display PDF in Browser (Acrobat 5.x - 7.x or Acrobat Reader 5.x - 7.x).
  6. Click OK, and then exit from Acrobat or Acrobat Reader.
  7. Restart Netscape, Internet Explorer or AOL.
Note: The next time you select a link to a PDF file in Internet Explorer and AOL, a dialog box will prompt you to specify what to do with the file. If you select "Open this file from its current location," Internet Explorer and AOL open the PDF file in Acrobat 5.0 or later or Acrobat Reader 5.0 or later as a helper application. If you select "Save this file to disk," Internet Explorer saves the PDF file to your hard disk, from where you can open it later.


Users Can't Access My Web Server

Question

I can view my web server fine on my computer but other users on the internet cannot see my site.
I have no firewall and I'm not behind a router, what is wrong?

Answer

Some ISP (Internet Service Providers) block the use of Port 80 (The default port for Web Servers), we recommend configuring NetServe to another Port setting, perhaps 876 and then trying again.

Please note that if using a port other than port 80, users wishing to view your web site will need to type the URL as follows: http://XXX.XXX.XXX.XXX:876 Where XXX is your IP Address followed by a colon and then the port number.

You can find the port setting on NetServe's main options page, after changing the port setting in NetServe you should exit completely and then restart it for this change to take effect.


What Is The Best Router To Use?

Question

I would like to purchase an ADSL Router for use with your software, which is the best to buy?

Answer

Whilst we cannot recommend any specific router product we are in the process of testing various ADSL Routers in order for you, the user, to have the information you need to make the ultimate decision.

Below is a list of all ADSL Routers that have been tested and found to work with NetServe Web Server.
Product Name | No# Ports | Speed | Includes Wireless* | Manageable
Alcatel Pro + Firewall | 4 | 10 Base | No | Yes
Alcatel Speedtouch 530 | 1 + USB | 10/100 Base | No | Yes
Alcatel Speedtouch 610 | 4 | 10/100 Base | No | Yes
LinkSys Wireless AP (BEFW11S4) | 4 | 10/100 Base | Yes | Yes
Belkin Wireless ADSL Gateway (F5D7230-4) | 4 | 10/100 Base | Yes | Yes
BT Voyager 205 | 1 + USB | 10/100 Base | No | Yes
* Includes Wireless, indicates if the product includes Wireless as standard or has expansion slots intended for wireless upgrades. You can still upgrade any Small Or Home Office (SOHO) network to wireless by purchasing a Wireless Access Point.


NetServe Change History

NetServe Web Server Version 1.0.53

Copyright 2002-2006 Net-X Solutions Ltd

Changes from 1.0.52 - 1.0.53

  1. A Problem with renaming sites through the Remote Admin could cause a .dat file to be created that subsequently broke the ability to load multiple sites into memory. (Steve Kenney)
  2. Issue resolved that would cause Options Screen to display incorrectly on users machines running with a DPI other that the default 96dpi. (Ray Roberts)
  3. WebDAV issue resolved where clients requesting DEPTH 1 for a non folder resource caused the xml body to not be included in response. (Miguel Angelo)
  4. New File handling functions introduced, increases performance 2x for many file operations.
  5. FileSystemObject no longer a dependency resulting in smaller installer file.
  6. SiteList is no longer case sensitive, which resolves problems of site not responding as expected.
  7. New validation checks added for Site Lists in Remote Admin, renaming a site to a site that already exists now correctly prevents this action.
  8. Fixed issue where Quotas were case sensitive, this could case Quotas to not be used, when they should be.
  9. New checks prevent use of Illegal Registration Keys.
  • No known Issues with this software release, if you believe you have discovered a bug in NetServe or have suggestions please email support@netxsolutions.co.uk with details.


Technical Support

Regardless if you are a fully registered user or still using a trial version of our product, we are more than happy to offer you technical support so that you may get the most out of your use of NetServe Web Server.

Should you have technical questions concerning installation or use, or believe you have encountered a bug in the product, please contact us either via email at support@netxsolutions.co.uk or at our support site at www.netxsolutions.co.uk/support.html.

If contacting us via email please be sure to include the following details, Application Name, version, Operating System, and any details that may be useful.


Purchasing NetServe

NetServe Web Server is packed with so many feature yet is still available at a remarkably low price.

You can purchase NetServe securely through the RegNow service, available 24 hours a day.

Once your purchase has been processed (Usually with minutes), our server automatically sends you your registration details via email, which you can use to activate NetServe Web Server.

To purchase NetServe securely over the internet, click our Buy Now link.